#include <oslib/oslib.h>
PSP_MODULE_INFO("Shooter",0,1,1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);//<<this is required(for osl?) or it just hangs
//pointers
OSL_IMAGE *back, *star, *ship, *laser, *joke1,*joke2, *joke3, *joke4, *joke5;
//variables
int staryfix=1,shooting=0,shootingCTRL=0,hits=0;
//function declarations
void AnimateBackground();
void Draw();
void Fire();
void hit();
//PSPJOKE!!!
void setupEffect();
void Effect();

int main(){
    oslInit(0);
    oslInitGfx(OSL_PF_8888, 1);
    oslSetTransparentColor(RGB(255,0,255));
    back = oslLoadImageFilePNG("black.png", OSL_IN_RAM, OSL_PF_5551);
    star = oslLoadImageFilePNG("star.png", OSL_IN_RAM, OSL_PF_5551);
    ship = oslLoadImageFilePNG("ship.png",OSL_IN_RAM, OSL_PF_5551);
    laser = oslLoadImageFilePNG("laser.png",OSL_IN_RAM,OSL_PF_5551);
    if (!back || !star || !ship || !laser){
        oslDebug("You are missing files. Press triangle to exit..");
        oslQuit();}
    star->x = 500;
    star->y = 20;
    ship->x = 0;
    ship->y = 136;
    setupEffect();
    while(!osl_quit){
                     Effect();
                     oslReadKeys();
                     if(osl_keys->held.up)ship->y--;
                     if(osl_keys->held.down)ship->y++;
                     if(osl_keys->pressed.cross && shooting!=1)shooting=1;
                     if(shooting==1)Fire();
                     AnimateBackground();
                     Draw();
                     }
    oslEndGfx();
    oslQuit();
    return 0;}


void AnimateBackground(){
     if(star->x<=-20){
                      star->x = 500;
                      staryfix++;
                      if(staryfix>=7)staryfix=1;}
     if(staryfix==1)star->y=34;//had to use a variable "staryfix" because for some dumb reason star->y wouldn't work correctly.
     if(staryfix==2)star->y=172;
     if(staryfix==3)star->y=252;
     if(staryfix==4)star->y=153;
     if(staryfix==5)star->y=226;
     if(staryfix==6)star->y=136;
     star->x-=3;}
    

void Fire(){
     //get laser ready
     if(shootingCTRL!=1){
     laser->x=ship->x+30;
     laser->y=ship->y+10;
     shootingCTRL=1;}
     //move laser and check collision
     if(laser->x>=star->x && laser->x<=star->x+20 && laser->y>=star->y && laser->y<=star->y+20)hit();
     laser->x+=3;
     if(laser->x>=490){
                       shooting=0;
                       shootingCTRL=0;}}
     
void hit(){
     shootingCTRL=0;
     shooting=0;
     hits++;
     star->x=-20;
     Draw();
     oslDebug("you hit the target %i times!!!",hits);}
    
void Draw(){//remember that when drawing, what you draw first is the first layer, second is second layer...
     oslStartDrawing();
     oslDrawImage(back);
     //PSPJOKE!!!!!
     oslDrawImage(joke1);
     oslDrawImage(joke2);
     oslDrawImage(joke3);
     oslDrawImage(joke4);
     oslDrawImage(joke5);
     //end joke
     oslDrawImage(star);
     oslDrawImage(ship);
     if(shooting==1)oslDrawImage(laser);
     oslEndDrawing();
     oslSyncFrame();}
    




//PSPJOKE

void setupEffect(){
     joke1 = oslLoadImageFilePNG("pspjoke.png", OSL_IN_RAM, OSL_PF_5551);
     joke2 = oslLoadImageFilePNG("pspjoke.png", OSL_IN_RAM, OSL_PF_5551);
     joke3 = oslLoadImageFilePNG("pspjoke.png", OSL_IN_RAM, OSL_PF_5551);
     joke4 = oslLoadImageFilePNG("pspjoke.png", OSL_IN_RAM, OSL_PF_5551);
     joke5 = oslLoadImageFilePNG("pspjoke.png", OSL_IN_RAM, OSL_PF_5551);
     if(!joke1 || !joke2 || !joke3 || !joke4 || !joke5){
               oslDebug("you are missing files...");
               oslQuit();}
     joke1->x=27;
     joke1->y=32;
     joke2->x=262;
     joke2->y=80;
     joke3->x=189;
     joke3->y=137;
     joke4->x=58;
     joke4->y=189;
     joke5->x=377;
     joke5->y=227;
     }
               
               
/*void Effect(){
     if(joke1->x<=-73)joke1->x=553;
     if(joke2->x<=-73)joke2->x=553;
     if(joke3->x<=-73)joke3->x=553;
     if(joke4->x<=-73)joke4->x=553;
     if(joke5->x<=-73)joke5->x=553;
     joke1->x--;
     joke2->x--;
     joke3->x--;
     joke4->x--;
     joke5->x--;}*/
     
     void Effect(){
     if(joke1->x<=-73)joke1->x=553;
     if(joke2->x>=553)joke2->x=-73;
     if(joke3->x<=-73)joke3->x=553;
     if(joke4->x>=553)joke4->x=-73;
     if(joke5->x<=-73)joke5->x=553;
     joke1->x-=4;
     joke2->x+=7;
     joke3->x-=2;
     joke4->x+=8;
     joke5->x-=3;}
